/**
 * @desc: 广告
 * @Create Date: 2019-08-29 16:05:02
 * @Last Modified time: 2019-08-29 16:05:02
 */
const { ccclass, property } = cc._decorator

@ccclass
export default class Ad extends cc.Component {
  @property(cc.Button)
  returnBtn: cc.Button = null

  @property(cc.Node)
  bannerAd: cc.Node = null

  @property(cc.Node)
  rewardVideoAd: cc.Node = null

  @property(cc.Node)
  insertAd: cc.Node = null

  @property(cc.Node)
  interstitialVideoAd: cc.Node = null

  @property(cc.Node)
  nativeAd: cc.Node = null

  start() {
    // 跳转到 Banner 广告
    this.bannerAd.on(cc.Node.EventType.TOUCH_START, event => {
      cc.director.loadScene('bannerAd')
    })
    // 跳转到 激励视频 广告
    this.rewardVideoAd.on(cc.Node.EventType.TOUCH_START, event => {
      cc.director.loadScene('rewardVideoAd')
    })
    // 跳转到 插屏 广告
    this.insertAd.on(cc.Node.EventType.TOUCH_START, event => {
      cc.director.loadScene('insertAd')
    })
    // 跳转到 原生 广告
    this.nativeAd.on(cc.Node.EventType.TOUCH_START, event => {
      cc.director.loadScene('nativeAd')
    })
    // 跳转到 插屏视频 广告
    this.interstitialVideoAd.on(cc.Node.EventType.TOUCH_START, event => {
      cc.director.loadScene('interstitialVideoAd')
    })
  }

  onClickReturnBtn() {
    cc.director.loadScene('main')
  }
}
