/**
 * @desc: 原生广告
 * @Create Date: 2019-08-26 11:42:34
 * @Last Modified time: 2019-08-26 11:43:31
 */
const { ccclass, property } = cc._decorator

@ccclass
export default class NativeAd extends cc.Component {
  @property(cc.Button)
  returnBtn: cc.Button = null

  @property(cc.Node)
  smallNativeAdBtn: cc.Node = null

  @property(cc.Node)
  bigNativeAdBtn: cc.Node = null

  start() {
    this.smallNativeAdBtn.on(cc.Node.EventType.TOUCH_START, () => {
      cc.director.loadScene('smallNativeAd')
    })
    this.bigNativeAdBtn.on(cc.Node.EventType.TOUCH_START, () => {
      cc.director.loadScene('bigNativeAd')
    })
  }

  onClickReturnBtn() {
    cc.director.loadScene('ad')
  }
}
